--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------
--variables-------------------------------------------

--is line not empty checker function
  local function isLineEmpty(lineID, columnID, patTrack)
    --local patTrack = renoise.song().selected_pattern_track
     local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
    -- Check if the line is not empty
        if deviceString ~= "00" then
          return false
        else
        return true
        end
    end

--interpolator
local function interpolate(stepCounter, startValue, endValue, curStep)
        return (startValue) + ((curStep / stepCounter) * (endValue-startValue))
end

--main function
local function InterpolateBeyond()
    -- Initialize the variables
    print("____INTERPOLATE___")
    local track = renoise.song().selected_track
     local lineID = renoise.song().selected_line_index--variable for the first line
    local lineDown = lineID + 1
    local lineUp = lineID - 1
    local trackID = renoise.song().selected_track_index
    local patternID = renoise.song().selected_pattern_index
    local patTrack = renoise.song().patterns[patternID]:track(trackID)
    local columnID = renoise.song().selected_effect_column_index
    if columnID ~= 0 then
    if not isLineEmpty(lineID,columnID,patTrack) then 
    local effect = patTrack:line(lineDown).effect_columns[columnID]
    local pattern = renoise.song().selected_pattern
    local patternLength
    local parameter = renoise.song().selected_parameter 
    local patternNext = patternID
    local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
    local deviceID = 1
    local deviceStringSplit = 1
    local deviceParamID 
    local parameterOld

  if deviceString ~= "00" then
   deviceID = tonumber(string.sub(deviceString, 1, 1))+1
   deviceStringSplit = tonumber(deviceString:sub(2))
   deviceParamID = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit]
    parameterOld = math.floor((255 / (deviceParamID.value_max - deviceParamID.value_min)) * (deviceParamID.value - deviceParamID.value_min) + 0.5)     --gets the value of the parameter on the device currently
  end
    local patCount= #renoise.song().patterns
   
    --get starting value
    local parameterStart = patTrack:line(lineID).effect_columns[columnID].amount_value
    local parameterID = renoise.song().selected_automation_parameter
    if parameterID ~= "00" then
    local patTrackNext = renoise.song().patterns[patternNext]:track(trackID)
    local stepCounter = 0
    local curStep = 0
    local endOfProject = false
    
--Find next modulation point
  while isLineEmpty(lineDown,columnID,renoise.song().patterns[patternNext]:track(trackID))  do
       -- print(stepCounter)
        lineDown = lineDown + 1
        stepCounter = stepCounter+1
        patternLength = renoise.song().patterns[patternNext].number_of_lines
          if lineDown == patternLength+1 then
             patternNext = patternNext+1
             lineDown = 1
          end
          if patternNext > patCount then
          patternNext = patternNext-1
          endOfProject = true
          stepCounter = stepCounter-1
          break
          end
             --  print(lineDown)
      -- print(patternNext)
end
    local parameterEnd
    --get end values
    if endOfProject == false then
    parameterEnd = renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].amount_value
    else
    parameterEnd = parameterOld
    end
   -- print(parameterStart)
   -- print(parameterEnd)
   
     --reset linedown and patternNext
  lineDown = lineID+1
  patternNext = patternID
  
  --interpolate value at each point
    while isLineEmpty(lineDown,columnID,renoise.song().patterns[patternNext]:track(trackID)) do
      local stepValue = interpolate(stepCounter, parameterStart, parameterEnd, curStep)
              patternLength = renoise.song().patterns[patternNext].number_of_lines

       renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].amount_value = stepValue
       renoise.song().patterns[patternNext]:track(trackID):line(lineDown).effect_columns[columnID].number_string = deviceString
       lineDown = lineDown + 1
       curStep = curStep+1
          if lineDown == patternLength+1 then
             patternNext = patternNext+1
             lineDown = 1
          end
           if patternNext > patCount then --ends loop if it gets to the end of available patterns
          break
          end
    end
  end
end
end
end
--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------
--[[
renoise.tool():add_menu_entry {
  name = "Main Menu:Edit:"..tool_name,
  invoke = ParameterLock
}
--]]

--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------


renoise.tool():add_keybinding {
  name = "Global:Tools:" .. tool_name,
  invoke = InterpolateBeyond
}

